JavaScript Data GridSelection

Select a single cell, a range of adjacent cells, or multiple non-adjacent ranges of cells.

Overview

Selection enables you to select a single cell or ranges of cells within Handsontable. Once selected, you can retrieve data from the cell, edit the cell's contents, or change the style of the cell.

Basic configuration

With this feature, you can select single cells or ranges of cells across a grid. Easily retrieve the coordinates of the selected cells to clear or change the cells' content.

Use Cmd on Mac or Ctrl on Windows to select non-adjacent ranges of cells.

Select ranges

There are different modes in which you can use this plugin. Choose between selecting a single cell, a range of adjacent cells, and multiple non-adjacent ranges of cells.

Possible values of selectionMode:

  • single - You can select a single cell.
  • range - You can select multiple cells within a single rangeselected.
  • multiple - You can select multiple, non-adjacent ranges of cells.

import Handsontable from 'handsontable';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

const container = document.querySelector('#example1');
const hot = new Handsontable(container, {
  data: [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'],
    ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'],
    ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'],
    ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'],
    ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'],
  ],
  width: 'auto',
  height: 'auto',
  colWidths: 100,
  rowHeaders: true,
  colHeaders: true,
  selectionMode: 'multiple',
  autoWrapRow: true,
  autoWrapCol: true,
  licenseKey: 'non-commercial-and-evaluation',
});

const selectOption = document.querySelector('#selectOption');

selectOption.addEventListener('change', (event) => {
  const value = event.target.value;
  const first = value.split(' ')[0].toLowerCase();

  hot.updateSettings({ selectionMode: first });
});

Get data from the selected ranges

To retrieve the selected cells as an array of arrays, you use the getSelected() or getSelectedRange() methods.

Here you will see the log
import Handsontable from 'handsontable';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

const container = document.querySelector('#example2');
const hot = new Handsontable(container, {
  data: [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'],
    ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'],
    ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'],
    ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'],
    ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'],
  ],
  width: 'auto',
  height: 'auto',
  colWidths: 100,
  rowHeaders: true,
  colHeaders: true,
  outsideClickDeselects: false,
  selectionMode: 'multiple',
  autoWrapRow: true,
  autoWrapCol: true,
  licenseKey: 'non-commercial-and-evaluation',
});

const getButton = document.querySelector('#getButton');
const output = document.querySelector('#output');

getButton.addEventListener('click', () => {
  const selected = hot.getSelected() || [];
  let data = [];

  if (selected.length === 1) {
    data = hot.getData(...selected[0]);
  } else {
    for (let i = 0; i < selected.length; i += 1) {
      data.push(hot.getData(...selected[i]));
    }
  }

  output.innerText = JSON.stringify(data);
});

Modify the selected cells

You may want to delete, format, or otherwise change the selected cells. For example, you can change a value or add CSS classes to the selected cells using the demo below.

import Handsontable from 'handsontable';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

const container = document.querySelector('#example3');
const hot = new Handsontable(container, {
  data: [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'],
    ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'],
    ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'],
    ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'],
    ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'],
  ],
  width: 'auto',
  height: 'auto',
  colWidths: 100,
  rowHeaders: true,
  colHeaders: true,
  outsideClickDeselects: false,
  selectionMode: 'multiple',
  autoWrapRow: true,
  autoWrapCol: true,
  licenseKey: 'non-commercial-and-evaluation',
});

const button = document.querySelector('#set-data-action');

button.addEventListener('click', () => {
  const selected = hot.getSelected() || [];

  hot.suspendRender();

  for (let index = 0; index < selected.length; index += 1) {
    const [row1, column1, row2, column2] = selected[index];
    const startRow = Math.max(Math.min(row1, row2), 0);
    const endRow = Math.max(row1, row2);
    const startCol = Math.max(Math.min(column1, column2), 0);
    const endCol = Math.max(column1, column2);

    for (let rowIndex = startRow; rowIndex <= endRow; rowIndex += 1) {
      for (let columnIndex = startCol; columnIndex <= endCol; columnIndex += 1) {
        hot.setDataAtCell(rowIndex, columnIndex, 'data changed');
        hot.setCellMeta(rowIndex, columnIndex, 'className', 'c-red');
      }
    }
  }

  hot.render();
  hot.resumeRender();
});

Style the selection area

You can easily change the background color, using CSS styles. The main, light blue background color is defined in the .area class.

For non-adjacent selection, multiple classes are making each level a bit darker. These classes are called area-1, area-2, etc.

Unfortunately, there is no easy way to change the border color of the selection.

Jump across the grid's edges

When you use keyboard navigation to cross an edge of the grid, you can set cell selection to jump to the opposite edge.

Jump across vertical edges

To enable jumping across the left and right edges:

To jump across a vertical edge:

  • When cell selection is on a row's first cell, press the left arrow key.
  • When cell selection is on a row's last cell, press the right arrow key, or press Tab.

Jump across horizontal edges

To enable jumping across the top and bottom edges:

To jump across a horizontal edge:

  • When cell selection is on a column's first cell, press the up arrow key.
  • When cell selection is on a column's last cell, press the down arrow key, or press Enter.
Windows macOS Action Excel Sheets
Ctrl+A Cmd+A Select all cells
Ctrl+Shift+Space Cmd+Shift+Space Select all cells and headers
Ctrl+Space Ctrl+Space Select the entire column
Shift+Space Shift+Space Select the entire row
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the first cell of the current column**
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the last cell of the current column**
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the leftmost cell of the current row**
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the rightmost cell of the current row**
Shift + Arrow keys Shift + Arrow keys Extend the selection by one cell
Shift+Home Shift+Home Extend the selection to the first non-frozen cell of the current row*
Shift+End Shift+End Extend the selection to the last non-frozen cell of the current row*
Shift+Page Up Shift+Page Up Extend the selection by one screen up
Shift+Page Down Shift+Page Down Extend the selection by one screen down
Ctrl+Enter Cmd+Enter Fill the selected range of cells with the value of the active cell
Delete Delete Clear the contents of the selected cells
Backspace Backspace Clear the contents of the selected cells

* This action depends on your layout direction.
** In case of multiple selection layers, only the last selection layer gets extended.

Selection
Select a single cell, a range of adjacent cells, or multiple non-adjacent ranges of cells.
Use the selection API to control how users select cells — single cells, ranges, columns, or rows — and to read or set selections programmatically.
Overview
Selection enables you to select a single cell or ranges of cells within Handsontable. Once selected, you can retrieve data from the cell, edit the cell’s contents, or change the style of the cell.
Basic configuration
With this feature, you can select single cells or ranges of cells across a grid. Easily retrieve the coordinates of the selected cells to clear or change the cells’ content.
Use ⌘ on Mac or Ctrl on Windows to select non-adjacent ranges of cells.
Click a column header to select all cells in that column. Click a row header to select all cells in that row. Both require colHeaders or rowHeaders to be enabled.
Select ranges
There are different modes in which you can use this plugin. Choose between selecting a single cell, a range of adjacent cells, and multiple ranges of non-contiguous cells.
Possible values of selectionMode:
single- You can select a single cell.range- You can select multiple cells within a single rangeselected.multiple- Multiple non-contiguous ranges of cells can be selected.
<script setup lang="ts">import { computed, onMounted, onUnmounted, ref, useTemplateRef } from 'vue';import { HotTable } from '@handsontable/vue3';import { registerAllModules } from 'handsontable/registry';import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const options = [ { value: 'single', label: 'Single selection' }, { value: 'range', label: 'Range selection' }, { value: 'multiple', label: 'Multiple ranges selection' },] as const;
const dropdownRef = useTemplateRef<HTMLDivElement>('dropdownRef');const isOpen = ref(false);const selected = ref<'single' | 'range' | 'multiple'>('multiple');
const selectedLabel = computed(() => options.find((o) => o.value === selected.value)?.label);
const hotSettings = computed<GridSettings>(() => ({ data: [ ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'], ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'], ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'], ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'], ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'], ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'], ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'], ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'], ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'], ], width: 'auto', height: 'auto', colWidths: 100, rowHeaders: true, colHeaders: true, selectionMode: selected.value, autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',}));
const handleOutsideClick = (e: MouseEvent) => { if (dropdownRef.value && !dropdownRef.value.contains(e.target as Node)) { isOpen.value = false; }};
const handleEscape = (e: KeyboardEvent) => { if (e.key === 'Escape') { isOpen.value = false; }};
onMounted(() => { document.addEventListener('click', handleOutsideClick); document.addEventListener('keydown', handleEscape);});
onUnmounted(() => { document.removeEventListener('click', handleOutsideClick); document.removeEventListener('keydown', handleEscape);});
const handleSelect = (value: 'single' | 'range' | 'multiple') => { selected.value = value; isOpen.value = false;};</script>
<template> <div id="example1"> <div class="example-controls-container"> <div class="controls"> <div ref="dropdownRef" class="theme-dropdown"> <button class="theme-dropdown-trigger" type="button" aria-haspopup="listbox" :aria-expanded="isOpen" @click="isOpen = !isOpen" > <span>{{ selectedLabel }}</span> <svg class="theme-dropdown-chevron" aria-hidden="true" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" > <path d="M6 9l6 6l6 -6" /> </svg> </button> <ul v-if="isOpen" class="theme-dropdown-menu" role="listbox"> <li v-for="opt in options" :key="opt.value" role="option" :aria-selected="selected === opt.value" @click="handleSelect(opt.value)" > {{ opt.label }} </li> </ul> </div> </div> </div> <HotTable :key="selected" :settings="hotSettings" /> </div></template>Get data from the selected ranges
To retrieve the selected cells as an array of arrays, you use the getSelected() or getSelectedRange() methods.
<script setup lang="ts">import { ref, useTemplateRef } from 'vue';import { HotTable } from '@handsontable/vue3';import { registerAllModules } from 'handsontable/registry';import type Handsontable from 'handsontable/base';import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotTableRef = useTemplateRef<InstanceType<typeof HotTable>>('hotTableRef');const output = ref('');
const hotSettings = ref<GridSettings>({ data: [ ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'], ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'], ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'], ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'], ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'], ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'], ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'], ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'], ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'], ], width: 'auto', height: 'auto', colWidths: 100, rowHeaders: true, colHeaders: true, outsideClickDeselects: false, selectionMode: 'multiple', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const getButtonClickCallback = () => { const hot = hotTableRef.value?.hotInstance; const selected = hot?.getSelected() || []; let data: Handsontable.CellValue[] = [];
if (selected.length === 1) { data = hot?.getData(...selected[0]!) || []; } else { for (let i = 0; i < selected.length; i += 1) { const item = selected[i];
data.push(hot?.getData(...item!)); } }
output.value = JSON.stringify(data);};</script>
<template> <div id="example2"> <div class="example-controls-container"> <div class="controls"> <button id="getButton" type="button" @click="getButtonClickCallback"> Get data </button> </div> <output id="output" class="console">{{ output }}</output> </div> <HotTable ref="hotTableRef" :settings="hotSettings" /> </div></template>Modify the selected cells
You may want to delete, format, or otherwise change the selected cells. For example, you can change a value or add CSS classes to the selected cells using the demo below.
<script setup lang="ts">import { ref, useTemplateRef } from 'vue';import { HotTable } from '@handsontable/vue3';import { registerAllModules } from 'handsontable/registry';import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotTableRef = useTemplateRef<InstanceType<typeof HotTable>>('hotTableRef');
const hotSettings = ref<GridSettings>({ data: [ ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'], ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'], ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'], ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'], ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'], ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'], ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'], ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'], ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'], ], width: 'auto', height: 'auto', colWidths: 100, rowHeaders: true, colHeaders: true, outsideClickDeselects: false, selectionMode: 'multiple', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const buttonClickCallback = () => { const hot = hotTableRef.value?.hotInstance; const selected = hot?.getSelected() || [];
hot?.suspendRender();
for (let index = 0; index < selected.length; index += 1) { const [row1, column1, row2, column2] = selected[index]; const startRow = Math.max(Math.min(row1, row2), 0); const endRow = Math.max(row1, row2); const startCol = Math.max(Math.min(column1, column2), 0); const endCol = Math.max(column1, column2);
for (let rowIndex = startRow; rowIndex <= endRow; rowIndex += 1) { for (let columnIndex = startCol; columnIndex <= endCol; columnIndex += 1) { hot?.setDataAtCell(rowIndex, columnIndex, 'data changed'); hot?.setCellMeta(rowIndex, columnIndex, 'className', 'c-red'); } } }
hot?.render(); hot?.resumeRender();};</script>
<template> <div id="example3"> <div class="example-controls-container"> <div class="controls"> <button id="set-data-action" type="button" @click="buttonClickCallback"> Click to modify the selected cells </button> </div> </div> <HotTable ref="hotTableRef" :settings="hotSettings" /> </div></template>
<style>.c-red { color: red;}</style>Style the selection area
You can change the background color of selected cells using CSS. The base selection color is defined in the .area class.
When using multiple non-adjacent selections (Cmd/Ctrl + click), each additional selection layer receives a numbered class: area-1 for the second layer, area-2 for the third, and so on. Each class is cumulative — a cell in the second layer has both area and area-1.
The example below customizes the color of each selection layer using these CSS classes.
<script setup lang="ts">import { ref } from 'vue';import { HotTable } from '@handsontable/vue3';import { registerAllModules } from 'handsontable/registry';import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotSettings = ref<GridSettings>({ data: [ ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'], ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'], ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'], ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'], ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'], ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'], ], width: 'auto', height: 'auto', colWidths: 100, rowHeaders: true, colHeaders: true, outsideClickDeselects: false, selectionMode: 'multiple', autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});</script>
<template> <div id="example4"> <HotTable :settings="hotSettings" /> </div></template>
<style>#example4 td.area { background-color: rgba(75, 137, 255, 0.2);}
#example4 td.area.area-1 { background-color: rgba(75, 137, 255, 0.4);}
#example4 td.area.area-2 { background-color: rgba(75, 137, 255, 0.6);}</style>Unfortunately, there is no easy way to change the border color of the selection.
Select cells programmatically
Use selectCell() to select a single cell or a range of cells from code. Pass the start and end row/column indices to define a range. Use deselectCell() to clear the selection.
<script setup lang="ts">import { ref, useTemplateRef } from 'vue';import { HotTable } from '@handsontable/vue3';import { registerAllModules } from 'handsontable/registry';import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotTableRef = useTemplateRef<InstanceType<typeof HotTable>>('hotTableRef');
const hotSettings = ref<GridSettings>({ data: [ ['A1', 'B1', 'C1', 'D1', 'E1', 'F1'], ['A2', 'B2', 'C2', 'D2', 'E2', 'F2'], ['A3', 'B3', 'C3', 'D3', 'E3', 'F3'], ['A4', 'B4', 'C4', 'D4', 'E4', 'F4'], ['A5', 'B5', 'C5', 'D5', 'E5', 'F5'], ['A6', 'B6', 'C6', 'D6', 'E6', 'F6'], ], width: 'auto', height: 'auto', colWidths: 100, rowHeaders: true, colHeaders: true, outsideClickDeselects: false, autoWrapRow: true, autoWrapCol: true, licenseKey: 'non-commercial-and-evaluation',});
const selectCell = () => { hotTableRef.value?.hotInstance?.selectCell(1, 1);};
const selectRange = () => { hotTableRef.value?.hotInstance?.selectCell(1, 1, 3, 3);};
const deselect = () => { hotTableRef.value?.hotInstance?.deselectCell();};</script>
<template> <div id="example5"> <div class="example-controls-container"> <div class="controls"> <button type="button" @click="selectCell"> Select cell B2 </button> <button type="button" @click="selectRange"> Select range B2:D4 </button> <button type="button" @click="deselect"> Deselect </button> </div> </div> <HotTable ref="hotTableRef" :settings="hotSettings" /> </div></template>Jump across the grid’s edges
When you use keyboard navigation to cross an edge of the grid, you can set cell selection to jump to the opposite edge.
Jump across vertical edges
To enable jumping across the left and right edges:
- Set the
autoWrapRowconfiguration option totrue.
To jump across a vertical edge:
- When cell selection is on a row’s first cell, press ←.
- When cell selection is on a row’s last cell, press →, or press Tab.
Jump across horizontal edges
To enable jumping across the top and bottom edges:
- Set the
autoWrapColconfiguration option totrue.
To jump across a horizontal edge:
- When cell selection is on a column’s first cell, press ↑.
- When cell selection is on a column’s last cell, press ↓, or press Enter.
Related keyboard shortcuts
| Windows | macOS | Action | Excel | Sheets |
|---|---|---|---|---|
| Ctrl+A | ⌘+A | Select all cells | ✓ | ✓ |
| Ctrl+Shift+Space | ⌘+⇧+Space | Select all cells and headers | ✓ | ✓ |
| Ctrl+Space | ⌃+Space | Select the entire column | ✓ | ✓ |
| Shift+Space | ⇧+Space | Select the entire row | ✓ | ✓ |
| Ctrl+Shift+↑ | ⌘+⇧+↑ | Extend the selection to the first cell of the current column** | ✓ | ✓ |
| Ctrl+Shift+↓ | ⌘+⇧+↓ | Extend the selection to the last cell of the current column** | ✓ | ✓ |
| Ctrl+Shift+← | ⌘+⇧+← | Extend the selection to the leftmost cell of the current row** | ✓ | ✓ |
| Ctrl+Shift+→ | ⌘+⇧+→ | Extend the selection to the rightmost cell of the current row** | ✓ | ✓ |
| Shift + Arrow keys | ⇧ + Arrow keys | Extend the selection by one cell | ✓ | ✓ |
| Shift+Home | ⇧+Home | Extend the selection to the first non-frozen cell of the current row* | ✓ | ✗ |
| Shift+End | ⇧+End | Extend the selection to the last non-frozen cell of the current row* | ✗ | ✗ |
| Shift+Page Up | ⇧+Page Up | Extend the selection by one screen up | ✓ | ✓ |
| Shift+Page Down | ⇧+Page Down | Extend the selection by one screen down | ✓ | ✓ |
| Ctrl+Enter | ⌘+Enter | Fill the selected range of cells with the value of the active cell | ✗ | ✓ |
| Delete | Delete | Clear the contents of the selected cells | ✓ | ✓ |
| Backspace | Backspace | Clear the contents of the selected cells | ✓ | ✓ |
* This action depends on your layout direction.
** In case of multiple selection layers, only the last selection layer gets extended.
Related API reference
Configuration options
Core methods
Hooks
Plugins
Result
Users can select cells using the configured mode — single cell, range, or multiple ranges. Programmatic selections take effect immediately and fire the relevant selection hooks.

Angular Data GridSelection

Select a single cell, a range of adjacent cells, or multiple non-adjacent ranges of cells.

Overview

Selection enables you to select a single cell or ranges of cells within Handsontable. Once selected, you can retrieve data from the cell, edit the cell's contents, or change the style of the cell.

Basic configuration

With this feature, you can select single cells or ranges of cells across a grid. Easily retrieve the coordinates of the selected cells to clear or change the cells' content.

Use Cmd on Mac or Ctrl on Windows to select non-adjacent ranges of cells.

Select ranges

There are different modes in which you can use this plugin. Choose between selecting a single cell, a range of adjacent cells, and multiple non-adjacent ranges of cells.

Possible values of selectionMode:

  • single - You can select a single cell.
  • range - You can select multiple cells within a single rangeselected.
  • multiple - You can select multiple, non-adjacent ranges of cells.

/* file: app.component.ts */
import {Component, ViewChild, ViewEncapsulation} from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';

@Component({
  selector: 'example1-selection',
  standalone: false,
  template: ` <div class="controls">
      <label>
        <select
          id="selectOption"
          (change)="selectOptionChange($event)"
          [value]="'multiple'"
        >
          <option value="single">Single selection</option>
          <option value="range">Range selection</option>
          <option value="multiple">Multiple ranges selection</option>
        </select>
      </label>
    </div>
    <div>
      <hot-table [data]="data" [settings]="gridSettings"></hot-table>
    </div>`,
  encapsulation: ViewEncapsulation.None
})
export class Example1SelectionComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  readonly data = [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'],
    ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'],
    ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'],
    ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'],
    ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'],
  ];

  readonly gridSettings: GridSettings = {
    width: 'auto',
    height: 'auto',
    colWidths: 100,
    rowHeaders: true,
    colHeaders: true,
    selectionMode: 'multiple', // 'single', 'range' or 'multiple',
    autoWrapRow: true,
    autoWrapCol: true
  };

  selectOptionChange(event: Event): void {
    const hot = this.hotTable?.hotInstance;
    type selection = 'multiple' | 'single' | 'range' | undefined;
    const value = (event.target as HTMLSelectElement).value;
    const first = value.split(' ')[0].toLowerCase() as selection;

    hot?.updateSettings({ selectionMode: first });
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example1SelectionComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example1SelectionComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example1SelectionComponent ]
})

export class AppModule { }

Get data from the selected ranges

To retrieve the selected cells as an array of arrays, you use the getSelected() or getSelectedRange() methods.

/* file: app.component.ts */
import {Component, ViewChild, ViewEncapsulation} from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';
import Handsontable from 'handsontable';

@Component({
  selector: 'example2-selection',
  standalone: false,
  template: ` <div class="example-controls-container">
      <div class="controls">
        <button id="getButton" (click)="getButtonClick()">Get data</button>
      </div>
      <output *ngIf="output" class="console" id="output"> {{ output }} </output>
    </div>
    <div>
      <hot-table [data]="data" [settings]="gridSettings"></hot-table>
    </div>`,
  encapsulation: ViewEncapsulation.None
})
export class Example2SelectionComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  readonly data = [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'],
    ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'],
    ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'],
    ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'],
    ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'],
  ];

  readonly gridSettings: GridSettings = {
    width: 'auto',
    height: 'auto',
    colWidths: 100,
    rowHeaders: true,
    colHeaders: true,
    outsideClickDeselects: false,
    selectionMode: 'multiple', // 'single', 'range' or 'multiple',
    autoWrapRow: true,
    autoWrapCol: true
  };

  output = '';

  getButtonClick(): void {
    const hot = this.hotTable?.hotInstance;
    const selected = hot?.getSelected() || [];
    let data: Handsontable.CellValue[] = [];

    if (selected.length === 1) {
      data = hot?.getData(...selected[0]!) || [];
    } else {
      for (let i = 0; i < selected.length; i += 1) {
        const item = selected[i];

        data.push(hot?.getData(...item));
      }
    }

    this.output = JSON.stringify(data);
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example2SelectionComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example2SelectionComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example2SelectionComponent ]
})

export class AppModule { }

Modify the selected cells

You may want to delete, format, or otherwise change the selected cells. For example, you can change a value or add CSS classes to the selected cells using the demo below.

/* file: app.component.ts */
import {Component, ViewChild, ViewEncapsulation} from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';

@Component({
  selector: 'example3-selection',
  standalone: false,
  template: ` <div class="controls">
      <button id="set-data-action" (click)="buttonClick()">
        Click to modify the selected cells
      </button>
    </div>
    <div>
      <hot-table [data]="data" [settings]="gridSettings"></hot-table>
    </div>`,
  encapsulation: ViewEncapsulation.None
})
export class Example3SelectionComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  readonly data = [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'],
    ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'],
    ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'],
    ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'],
    ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'],
  ];

  readonly gridSettings: GridSettings = {
    width: 'auto',
    height: 'auto',
    colWidths: 100,
    rowHeaders: true,
    colHeaders: true,
    outsideClickDeselects: false,
    selectionMode: 'multiple', // 'single', 'range' or 'multiple',
    autoWrapRow: true,
    autoWrapCol: true
  };

  output = '';

  buttonClick(): void {
    const hot = this.hotTable?.hotInstance;
    const selected = hot?.getSelected() || [];

    hot?.suspendRender();

    for (let index = 0; index < selected.length; index += 1) {
      const [row1, column1, row2, column2] = selected[index];
      const startRow = Math.max(Math.min(row1, row2), 0);
      const endRow = Math.max(row1, row2);
      const startCol = Math.max(Math.min(column1, column2), 0);
      const endCol = Math.max(column1, column2);

      for (let rowIndex = startRow; rowIndex <= endRow; rowIndex += 1) {
        for (
          let columnIndex = startCol;
          columnIndex <= endCol;
          columnIndex += 1
        ) {
          hot?.setDataAtCell(rowIndex, columnIndex, 'data changed');
          hot?.setCellMeta(rowIndex, columnIndex, 'className', 'c-red');
        }
      }
    }

    hot?.render();
    hot?.resumeRender();
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example3SelectionComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example3SelectionComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example3SelectionComponent ]
})

export class AppModule { }

Style the selection area

You can easily change the background color, using CSS styles. The main, light blue background color is defined in the .area class.

For non-adjacent selection, multiple classes are making each level a bit darker. These classes are called area-1, area-2, etc.

Unfortunately, there is no easy way to change the border color of the selection.

Jump across the grid's edges

When you use keyboard navigation to cross an edge of the grid, you can set cell selection to jump to the opposite edge.

Jump across vertical edges

To enable jumping across the left and right edges:

To jump across a vertical edge:

  • When cell selection is on a row's first cell, press the left arrow key.
  • When cell selection is on a row's last cell, press the right arrow key, or press Tab.

Jump across horizontal edges

To enable jumping across the top and bottom edges:

To jump across a horizontal edge:

  • When cell selection is on a column's first cell, press the up arrow key.
  • When cell selection is on a column's last cell, press the down arrow key, or press Enter.
Windows macOS Action Excel Sheets
Ctrl+A Cmd+A Select all cells
Ctrl+Shift+Space Cmd+Shift+Space Select all cells and headers
Ctrl+Space Ctrl+Space Select the entire column
Shift+Space Shift+Space Select the entire row
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the first cell of the current column**
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the last cell of the current column**
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the leftmost cell of the current row**
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the rightmost cell of the current row**
Shift + Arrow keys Shift + Arrow keys Extend the selection by one cell
Shift+Home Shift+Home Extend the selection to the first non-frozen cell of the current row*
Shift+End Shift+End Extend the selection to the last non-frozen cell of the current row*
Shift+Page Up Shift+Page Up Extend the selection by one screen up
Shift+Page Down Shift+Page Down Extend the selection by one screen down
Ctrl+Enter Cmd+Enter Fill the selected range of cells with the value of the active cell
Delete Delete Clear the contents of the selected cells
Backspace Backspace Clear the contents of the selected cells

* This action depends on your layout direction.
** In case of multiple selection layers, only the last selection layer gets extended.

React Data GridSelection

Select a single cell, a range of adjacent cells, or multiple non-adjacent ranges of cells.

Overview

Selection enables you to select a single cell or ranges of cells within Handsontable. Once selected, you can retrieve data from the cell, edit the cell's contents, or change the style of the cell.

Basic configuration

With this feature, you can select single cells or ranges of cells across a grid. Easily retrieve the coordinates of the selected cells to clear or change the cells' content.

Use Cmd on Mac or Ctrl on Windows to select non-adjacent ranges of cells.

Select ranges

There are different modes in which you can use this plugin. Choose between selecting a single cell, a range of adjacent cells, and multiple non-adjacent ranges of cells.

Possible values of selectionMode:

  • single - You can select a single cell.
  • range - You can select multiple cells within a single rangeselected.
  • multiple - You can select multiple, non-adjacent ranges of cells.

import { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const selectOptionChangeCallback = (event) => {
    const hot = hotRef.current?.hotInstance;
    const value = event.target.value;
    const first = value.split(' ')[0].toLowerCase();

    hot?.updateSettings({ selectionMode: first });
  };

  return (
    <>
      <div className="controls">
        <label>
          <select id="selectOption" onChange={(...args) => selectOptionChangeCallback(...args)} defaultValue="multiple">
            <option value="single">Single selection</option>
            <option value="range">Range selection</option>
            <option value="multiple">Multiple ranges selection</option>
          </select>
        </label>
      </div>
      <HotTable
        ref={hotRef}
        data={[
          ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'],
          ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'],
          ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'],
          ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'],
          ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'],
          ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'],
          ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'],
          ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'],
          ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'],
        ]}
        width="auto"
        height="auto"
        colWidths={100}
        rowHeaders={true}
        colHeaders={true}
        selectionMode="multiple" // 'single', 'range' or 'multiple',
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Get data from the selected ranges

To retrieve the selected cells as an array of arrays, you use the getSelected() or getSelectedRange() methods.

import { useRef, useState } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const [output, setOutput] = useState('');
  const getButtonClickCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const selected = hot?.getSelected() || [];
    let data = [];

    if (selected.length === 1) {
      data = hot?.getData(...selected[0]) || [];
    } else {
      for (let i = 0; i < selected.length; i += 1) {
        const item = selected[i];

        data.push(hot?.getData(...item));
      }
    }

    setOutput(JSON.stringify(data));
  };

  return (
    <>
      <div className="example-controls-container">
        <div className="controls">
          <button id="getButton" onClick={() => getButtonClickCallback()}>
            Get data
          </button>
        </div>
        <output className="console" id="output">
          {output}
        </output>
      </div>
      <HotTable
        ref={hotRef}
        data={[
          ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'],
          ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'],
          ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'],
          ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'],
          ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'],
          ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'],
          ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'],
          ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'],
          ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'],
        ]}
        width="auto"
        height="auto"
        colWidths={100}
        rowHeaders={true}
        colHeaders={true}
        outsideClickDeselects={false}
        selectionMode="multiple" // 'single', 'range' or 'multiple',
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Modify the selected cells

You may want to delete, format, or otherwise change the selected cells. For example, you can change a value or add CSS classes to the selected cells using the demo below.

import { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const buttonClickCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const selected = hot?.getSelected() || [];

    hot?.suspendRender();

    for (let index = 0; index < selected.length; index += 1) {
      const [row1, column1, row2, column2] = selected[index];
      const startRow = Math.max(Math.min(row1, row2), 0);
      const endRow = Math.max(row1, row2);
      const startCol = Math.max(Math.min(column1, column2), 0);
      const endCol = Math.max(column1, column2);

      for (let rowIndex = startRow; rowIndex <= endRow; rowIndex += 1) {
        for (let columnIndex = startCol; columnIndex <= endCol; columnIndex += 1) {
          hot?.setDataAtCell(rowIndex, columnIndex, 'data changed');
          hot?.setCellMeta(rowIndex, columnIndex, 'className', 'c-red');
        }
      }
    }

    hot?.render();
    hot?.resumeRender();
  };

  return (
    <>
      <div className="controls">
        <button id="set-data-action" onClick={() => buttonClickCallback()}>
          Click to modify the selected cells
        </button>
      </div>
      <HotTable
        ref={hotRef}
        data={[
          ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1'],
          ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2'],
          ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3'],
          ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4'],
          ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5'],
          ['A6', 'B6', 'C6', 'D6', 'E6', 'F6', 'G6', 'H6', 'I6'],
          ['A7', 'B7', 'C7', 'D7', 'E7', 'F7', 'G7', 'H7', 'I7'],
          ['A8', 'B8', 'C8', 'D8', 'E8', 'F8', 'G8', 'H8', 'I8'],
          ['A9', 'B9', 'C9', 'D9', 'E9', 'F9', 'G9', 'H9', 'I9'],
        ]}
        width="auto"
        height="auto"
        colWidths={100}
        rowHeaders={true}
        colHeaders={true}
        outsideClickDeselects={false}
        selectionMode="multiple" // 'single', 'range' or 'multiple',
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Style the selection area

You can easily change the background color, using CSS styles. The main, light blue background color is defined in the .area class.

For non-adjacent selection, multiple classes are making each level a bit darker. These classes are called area-1, area-2, etc.

Unfortunately, there is no easy way to change the border color of the selection.

Jump across the grid's edges

When you use keyboard navigation to cross an edge of the grid, you can set cell selection to jump to the opposite edge.

Jump across vertical edges

To enable jumping across the left and right edges:

To jump across a vertical edge:

  • When cell selection is on a row's first cell, press the left arrow key.
  • When cell selection is on a row's last cell, press the right arrow key, or press Tab.

Jump across horizontal edges

To enable jumping across the top and bottom edges:

To jump across a horizontal edge:

  • When cell selection is on a column's first cell, press the up arrow key.
  • When cell selection is on a column's last cell, press the down arrow key, or press Enter.
Windows macOS Action Excel Sheets
Ctrl+A Cmd+A Select all cells
Ctrl+Shift+Space Cmd+Shift+Space Select all cells and headers
Ctrl+Space Ctrl+Space Select the entire column
Shift+Space Shift+Space Select the entire row
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the first cell of the current column**
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the last cell of the current column**
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the leftmost cell of the current row**
Ctrl+Shift+ Cmd+Shift+ Extend the selection to the rightmost cell of the current row**
Shift + Arrow keys Shift + Arrow keys Extend the selection by one cell
Shift+Home Shift+Home Extend the selection to the first non-frozen cell of the current row*
Shift+End Shift+End Extend the selection to the last non-frozen cell of the current row*
Shift+Page Up Shift+Page Up Extend the selection by one screen up
Shift+Page Down Shift+Page Down Extend the selection by one screen down
Ctrl+Enter Cmd+Enter Fill the selected range of cells with the value of the active cell
Delete Delete Clear the contents of the selected cells
Backspace Backspace Clear the contents of the selected cells

* This action depends on your layout direction.
** In case of multiple selection layers, only the last selection layer gets extended.